//#define  MATLAB

#ifdef MATLAB
#include <stdlib.h>
#include <engine.h>
#endif

#include <math.h>
#include <Windows.h>
#include <stdio.h>
#include <conio.h>

#define  NMOLECULAR 13
#define  NREACTION 29
#define  NTIME 20000
#define  RUNTIME 100

double pResult[NREACTION];

double omega=0.1;     			//cell volume
double dconst=1.0/30.0;			//rate of dilution
double lfBase = 0*omega;		//base expression

double k1=46.67*omega;
double k2=14*omega;
double k3=(1.0/60+dconst);
double k4=0.08;
double k5=1.0/40.0;
double k6=dconst;
double k7=1.5625*omega;
double k8=0.5*omega;
double k9=(1.0/4.4+dconst);
double k10=2.68*0.05;
double k11=0.3;
double k12=(1.0/40+dconst);
double k13=5.6*omega;

double k14=3*omega;
double k15=5.6*omega;
double k16=40*omega;
double k17=50*omega;
double k18=1*omega;
double k19=(1.0/4.4+dconst);
double k20=(1.0/4.4+dconst);
double k21=9.6*0.09;					
double k22=9.6*0.09;					
double k23=(1.0/44+dconst);
double k24=5.92*omega;
double k25=40*omega;
double k26=1.0/4.4+dconst;
double k27=10.14*1;				
double k28=1.0/11+dconst;
double k29=1.75*omega;
double k30=40*omega;
double k31=1*omega;
double k32=50*omega;
double k33=1.0/4.4+dconst;
double k34=3*0.15;
double k35=0.3;
double k36=1.0/30+dconst;
double k37=5.25*omega;
double k38=0.5*omega;
double k39=5.25*omega;
double k40=55*omega;
double k41=1.0/4.4+dconst;
double k42=9*1;
double k43=(1.0/60+dconst);

double* Getw(double u, double v, double x[NMOLECULAR]);
inline double Sum(double* a);
inline int Evolution(int* nRecord, double* lfTime, int nStemp, int nUSignal, int nVSignal,
					 double* x, double* plfTime, double*** pnXnum, int s[13][29],
					 double* pSingalU, double* pSingalV);

int main()
{	

	double t=0;

	double x[NMOLECULAR]={0,0,0,0,0,0,0,0,0,0,0,0};

	int s[NMOLECULAR][NREACTION]=
	{{1,-1,-1,1,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0},
	{0,0,1,-1,-1,0,0,-2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-2,0,0,0,0,0,0},
	{0,0,0,0,0,1,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
	{0,0,0,0,0,0,0,1,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
	{0,0,0,0,0,0,0,0,0,1,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
	{0,0,0,0,0,0,0,0,0,0,1,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
	{0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,-1,0,0,0,0,0,0,0,0,0,0,0,0,0},
	{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,-1,0,0,0,0,0,0,0,0,0,0,0},
	{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,-1,0,0,0,0,0,0,0,0,0},
	{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,-1,0,0,0,0,0,0,0},
	{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,-1,0,0,0,0,0},
	{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,-1,0,0},
	{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,-1}};


	double* plfTime = 0;
	double*** pnXnum = 0;
	int i, j, k;
	int l, m;
	int nRunTime;
	int nSignal = 40;
	int nRecord;
	double* plfSignalu;
	double* plfSignalv;

	plfTime = new double[NTIME];
	ZeroMemory(plfTime, sizeof(double)*NTIME);
	pnXnum = new double**[2];
	for (j = 0; j < 2; j++)
	{
		pnXnum[j] = new double*[NMOLECULAR];
		for (i = 0; i < NMOLECULAR; i++)
		{
			pnXnum[j][i] = new double[NTIME];
			ZeroMemory(pnXnum[j][i], sizeof(double)*NTIME);
		}
	}
	plfSignalu = new double[NTIME];
	ZeroMemory(plfSignalu, sizeof(double)*NTIME);
	plfSignalv = new double[NTIME];
	ZeroMemory(plfSignalv, sizeof(double)*NTIME);

	srand(GetTickCount());
	FILE* hData;
	hData = fopen("DataRecord.dat", "w");
	nRecord = 0;
	for (l = 0; l < 1000; l++)
	{
		//x[6]=30;		//CI
		//x[8]=200;		//CI434
		ZeroMemory(x, sizeof(double)*NMOLECULAR);
		nRunTime = GetTickCount();
		t=0;

		/*nRecord = Evolution(&nRecord, &t, 200, 0, 0, x, plfTime, pnXnum, s, plfSignalu, plfSignalv);
		nRecord = Evolution(&nRecord, &t, 5, 0, nSignal, x, plfTime, pnXnum, s, plfSignalu, plfSignalv);
		nRecord = Evolution(&nRecord, &t, 200, 0, 0, x, plfTime, pnXnum, s, plfSignalu, plfSignalv);*/


		//**********************************************************************//
		nRecord = Evolution(&nRecord, &t, 200, 0, 0, x, plfTime, pnXnum, s, plfSignalu, plfSignalv);
		nRecord = Evolution(&nRecord, &t, 5, nSignal, nSignal, x, plfTime, pnXnum, s, plfSignalu, plfSignalv);
		nRecord = Evolution(&nRecord, &t, 200, 0, 0, x, plfTime, pnXnum, s, plfSignalu, plfSignalv);
		nRecord = Evolution(&nRecord, &t, 5, nSignal, 0, x, plfTime, pnXnum, s, plfSignalu, plfSignalv);
		nRecord = Evolution(&nRecord, &t, 200, 0, 0, x, plfTime, pnXnum, s, plfSignalu, plfSignalv);
		nRecord = Evolution(&nRecord, &t, 5, nSignal, nSignal, x, plfTime, pnXnum, s, plfSignalu, plfSignalv);
		nRecord = Evolution(&nRecord, &t, 200, 0, 0, x, plfTime, pnXnum, s, plfSignalu, plfSignalv);
		nRecord = Evolution(&nRecord, &t, 5, nSignal, 0, x, plfTime, pnXnum, s, plfSignalu, plfSignalv);
		nRecord = Evolution(&nRecord, &t, 200, 0, 0, x, plfTime, pnXnum, s, plfSignalu, plfSignalv);
		nRecord = Evolution(&nRecord, &t, 5, nSignal, nSignal, x, plfTime, pnXnum, s, plfSignalu, plfSignalv);
		nRecord = Evolution(&nRecord, &t, 200, 0, 0, x, plfTime, pnXnum, s, plfSignalu, plfSignalv);
		nRecord = Evolution(&nRecord, &t, 5, nSignal, 0, x, plfTime, pnXnum, s, plfSignalu, plfSignalv);
		nRecord = Evolution(&nRecord, &t, 200, 0, 0, x, plfTime, pnXnum, s, plfSignalu, plfSignalv);
		nRecord = Evolution(&nRecord, &t, 5, nSignal, nSignal, x, plfTime, pnXnum, s, plfSignalu, plfSignalv);
		nRecord = Evolution(&nRecord, &t, 200, 0, 0, x, plfTime, pnXnum, s, plfSignalu, plfSignalv);
		nRecord = Evolution(&nRecord, &t, 5, nSignal, 0, x, plfTime, pnXnum, s, plfSignalu, plfSignalv);
		nRecord = Evolution(&nRecord, &t, 200, 0, 0, x, plfTime, pnXnum, s, plfSignalu, plfSignalv);
		nRecord = Evolution(&nRecord, &t, 5, nSignal, nSignal, x, plfTime, pnXnum, s, plfSignalu, plfSignalv);
		nRecord = Evolution(&nRecord, &t, 200, 0, 0, x, plfTime, pnXnum, s, plfSignalu, plfSignalv);
		nRecord = Evolution(&nRecord, &t, 5, nSignal, 0, x, plfTime, pnXnum, s, plfSignalu, plfSignalv);
		nRecord = Evolution(&nRecord, &t, 200, 0, 0, x, plfTime, pnXnum, s, plfSignalu, plfSignalv);
		nRecord = Evolution(&nRecord, &t, 5, nSignal, nSignal, x, plfTime, pnXnum, s, plfSignalu, plfSignalv);
		nRecord = Evolution(&nRecord, &t, 200, 0, 0, x, plfTime, pnXnum, s, plfSignalu, plfSignalv);
		nRecord = Evolution(&nRecord, &t, 5, nSignal, 0, x, plfTime, pnXnum, s, plfSignalu, plfSignalv);
		nRecord = Evolution(&nRecord, &t, 400, 0, 0, x, plfTime, pnXnum, s, plfSignalu, plfSignalv);
		nRecord = Evolution(&nRecord, &t, 5, nSignal, 0, x, plfTime, pnXnum, s, plfSignalu, plfSignalv);
		nRecord = Evolution(&nRecord, &t, 400, 0, 0, x, plfTime, pnXnum, s, plfSignalu, plfSignalv);
		nRecord = Evolution(&nRecord, &t, 5, nSignal, 0, x, plfTime, pnXnum, s, plfSignalu, plfSignalv);
		nRecord = Evolution(&nRecord, &t, 400, 0, 0, x, plfTime, pnXnum, s, plfSignalu, plfSignalv);
		nRecord = Evolution(&nRecord, &t, 5, nSignal, 0, x, plfTime, pnXnum, s, plfSignalu, plfSignalv);
		nRecord = Evolution(&nRecord, &t, 400, 0, 0, x, plfTime, pnXnum, s, plfSignalu, plfSignalv);
		nRecord = Evolution(&nRecord, &t, 5, nSignal, 0, x, plfTime, pnXnum, s, plfSignalu, plfSignalv);
		nRecord = Evolution(&nRecord, &t, 400, 0, 0, x, plfTime, pnXnum, s, plfSignalu, plfSignalv);
		nRecord = Evolution(&nRecord, &t, 5, nSignal, 0, x, plfTime, pnXnum, s, plfSignalu, plfSignalv);
		nRecord = Evolution(&nRecord, &t, 400, 0, 0, x, plfTime, pnXnum, s, plfSignalu, plfSignalv);
		nRecord = Evolution(&nRecord, &t, 5, nSignal, 0, x, plfTime, pnXnum, s, plfSignalu, plfSignalv);
		nRecord = Evolution(&nRecord, &t, 400, 0, 0, x, plfTime, pnXnum, s, plfSignalu, plfSignalv);
		nRecord = Evolution(&nRecord, &t, 5, nSignal, 0, x, plfTime, pnXnum, s, plfSignalu, plfSignalv);
		nRecord = Evolution(&nRecord, &t, 400, 0, 0, x, plfTime, pnXnum, s, plfSignalu, plfSignalv);
		nRecord = Evolution(&nRecord, &t, 5, nSignal, 0, x, plfTime, pnXnum, s, plfSignalu, plfSignalv);
		nRecord = Evolution(&nRecord, &t, 400, 0, 0, x, plfTime, pnXnum, s, plfSignalu, plfSignalv);
		nRecord = Evolution(&nRecord, &t, 5, nSignal, 0, x, plfTime, pnXnum, s, plfSignalu, plfSignalv);
		nRecord = Evolution(&nRecord, &t, 400, 0, 0, x, plfTime, pnXnum, s, plfSignalu, plfSignalv);
		nRecord = Evolution(&nRecord, &t, 5, nSignal, 0, x, plfTime, pnXnum, s, plfSignalu, plfSignalv);
		nRecord = Evolution(&nRecord, &t, 300, 0, 0, x, plfTime, pnXnum, s, plfSignalu, plfSignalv);
		nRunTime = GetTickCount() - nRunTime;
		printf("%3d %d \n", l + 1, nRunTime);
		nRunTime = GetTickCount();
	}
	for (m = 5; m < nRecord - 5; m++)
	{
		fprintf(hData, "%d %lf %lf ", m, plfSignalu[m], plfSignalv[m]);
		for (k = 0; k < NMOLECULAR; k++)
		{
			if (pnXnum[1][k][m] != 0)
			{
				fprintf(hData, "%lf ", pnXnum[0][k][m]/pnXnum[1][k][m]);
			}
		}
		fprintf(hData, "\r\n");
	}
	fclose(hData);
#ifdef MATLAB
	{
		Engine* ep;
		ep = engOpen("\0");
		if (ep == NULL)
		{
			printf("Matlab open error!\n");
		}
		else
		{
			/*mxArray* mxTime;
			mxArray* mxResult;
			mxTime = mxCreateDoubleMatrix(nRecord, 1, mxREAL);
			mxResult = mxCreateDoubleMatrix(nRecord, NMOLECULAR, mxREAL);
			CopyMemory((char*)mxGetPr(mxTime), plfTime, sizeof(double)*nRecord);
			CopyMemory((char*)mxGetPr(mxResult), pnXnum, sizeof(double)*nRecord*NMOLECULAR);
			engPutVariable(ep, "T", mxTime);
			engPutVariable(ep, "Result", mxResult);*/
			engEvalString(ep,"a=load('dataRecord.dat'); \
							 b=1; \
							 a=a/100;");
			engEvalString(ep,"figure; \
							 plot(a(:,1),a(:,6+1)); \
							 title('CI');");
			engEvalString(ep,"figure; \
							 plot(a(:,1),a(:,8+1)); \
							 title('CI434');");
			engEvalString(ep,"figure; \
							 hold on; \
							 plot(a(:,1),a(:,6+1),'r'); \
							 plot(a(:,1),a(:,8+1),'g'); \
							 b=1;");
		/*	% figure; \
			% plot(a(:,1),a(:,2)); \
			% title('tRNA'); \
			% figure;   \
			% plot(a(:,1),a(:,3)); \
			% title('aa-tRNA'); \
			% figure; \
			% plot(a(:,1),a(:,4)); \
			% title('t7RNAP'); \
			% figure; \
			% plot(a(:,1),a(:,4+1)); \
			% title('T7'); \
			% figure; \
			% plot(a(:,1),a(:,5+1)); \
			% title('CImRNA'); \
			% figure; \
			% plot(a(:,1),a(:,6+1)); \
			% title('CI'); \
			% figure; \
			% plot(a(:,1),a(:,7+1)); \
			% title('CI434mRNA'); \
			% figure; \
			% plot(a(:,1),a(:,8+1)); \
			% title('CI434'); \
			% figure; \
			% plot(a(:,1),a(:,9+1)); \
			% title('T3mRNA'); \
			% figure; \
			% plot(a(:,1),a(:,10+1)); \
			% title('T3'); \
			% figure; \
			% plot(a(:,1),a(:,11+1)); \
			% title('GFPmRNA'); \
			% figure; \
			% plot(a(:,1),a(:,12+1)); \
			% title('GFP'); \
			% figure; \
			% hold on; \
			% plot(a(:,1),a(:,1+1),'r'); \
			% plot(a(:,1),a(:,2+1),'g'); \
			% plot(a(:,1),a(:,3+1),'b'); \
			% plot(a(:,1),a(:,4+1),'y'); \
			% plot(a(:,1),a(:,5+1),'or'); \
			% plot(a(:,1),a(:,6+1),'og'); \
			% plot(a(:,1),a(:,7+1),'ob'); \
			% plot(a(:,1),a(:,8+1),'oy'); \
			% plot(a(:,1),a(:,9+1),'+r'); \
			% plot(a(:,1),a(:,10+1),'+g'); \
			% plot(a(:,1),a(:,11+1),'+b'); \
			% plot(a(:,1),a(:,12+1),'+y'); \*/
			
		/*	 \
			*/
			getch();
			engClose(ep);
		}
	}
#endif
	delete[] plfTime;
	for (j = 0; j < 2; j++)
	{
		for (i = 0; i < NMOLECULAR; i++)
		{
			delete[] pnXnum[j][i];
		}
		delete[] pnXnum[j];
	}
	delete[] pnXnum;
	delete[] plfSignalu;
	delete[] plfSignalv;
}

double* Getw(double u, double v, double x[NMOLECULAR])
{

	lfBase = 1/100.0;
	double lfMult = 1;
	double lfDivi = 1;
	//-->tRNA;
	pResult[0]=k1*((pow(u/k2,2))/(1+pow(u/k2,2))+ lfBase);
	//tRNA-->0
	pResult[1]=k3*x[0];
	//tRNA-->aa-tRNA
	pResult[2]=k4*x[0];
	//aa-tRNA-->tRNA
	pResult[3]=k5*x[1];
	//aa-tRNA-->0
	pResult[4]=k6*x[1];
	//-->t7mRNA
	pResult[5]=k7*(pow(v/k8,2)/(1+pow(v/k8,2)) + lfBase);
	//t7mRNA-->
	pResult[6]=k9*x[2];
	//-->t7
	pResult[7]=k10*x[2]*(k11*x[1]/(1+k11*x[1]))*(k11*(x[1]-1)/(1.001+k11*(x[1]-1)));
	//t7-->
	pResult[8]=k12*x[3];
	//-->CImRNA(t7)
	pResult[9]=k13*(lfDivi*pow(x[3]/k14,2)/(1+pow(x[3]/k14,2))+lfBase);
	//-->CImRNA(CI)
	pResult[10]=k15*((lfDivi*pow(x[6]/k16,4)+k18)/(1+pow(x[6]/k16,4)+pow(x[8]/k17,2))+lfBase);
	//CImRNA(T7)-->0
	pResult[11]=k19*x[4];
	//CImRAN(CI)-->0
	pResult[12]=k20*x[5];
	//CImRNA(T7)-->CI
	pResult[13]=k21*x[4];
	//CImRAN(CI)-->CI
	pResult[14]=k22*x[5];

	//CI-->0
	pResult[15]=k23*x[6];
	//-->CI434mRNA
	pResult[16]=k24*(lfMult/(1+pow(x[6]/k25,4))+lfBase);
	//CI434mRNA-->
	pResult[17]=k26*x[7];
	//-->CI434
	pResult[18]=k27*5*x[7];
	//CI434-->
	pResult[19]=k28*x[8];
	//-->T3mRNA
	pResult[20]=k29*((pow(x[6]/k30,4)+k31)/(1+pow(x[6]/k30,4)+pow(x[8]/k32,2)) + lfBase);
	//T3mRNA-->0
	pResult[21]=k33*x[9];
	//-->T3
	pResult[22]=k34*x[9]*(k35*x[1]/(1+k35*x[1]))*(k35*(x[1]-1)/(1.001+k35*(x[1]-1)));
	//T3-->0
	pResult[23]=k36*x[10];
	//-->GFPmRNA(v)
	pResult[24]=k37*(pow(v/k38,2)/(1+pow(v/k38,2)) + lfBase);
	//-->GFPmRNA(T3)
	pResult[25]=k39*(pow(x[10]/k40,2)/(1+pow(x[10]/k40,2)) + lfBase);
	//GFPmRNA-->0
	pResult[26]=k41*x[11];
	//-->GFP
	pResult[27]=k42*x[11];
	//GFP-->0
	pResult[28]=k43*x[12];

	return pResult;
}

inline double Sum(double* a)
{
	int i;
	double lfRes=0;
	for (i = 0; i < NREACTION; i++)
	{
		lfRes+=a[i];
	}
	return lfRes;
}

inline int Evolution(int* nRecord, double* lfTime, int nStep, int nUSignal, int nVSignal,
					 double* x, double* plfTime, double*** pnXnum, int s[13][29],
					 double* pSingalU, double* pSingalV)
{
	double* a;
	int nTRecord;
	double w0;
	int nRand;
	double r2w0;
	int j;
	int k;
	double aTemp;
	double lfTlimit;

	lfTlimit = *lfTime+nStep;
	nTRecord = int(*lfTime);
	while(*lfTime<lfTlimit)
	{
		//*//*/
		//
		a=Getw(nUSignal,nVSignal,x);
		//
		w0=Sum(a);
		//
		nRand = rand();
		*lfTime=*lfTime+1/w0*log(((double)RAND_MAX+0.001)/(nRand+0.001));

		if(*lfTime<=lfTlimit)
		{
			//
			nRand = rand();
			r2w0=((double)nRand)/RAND_MAX*w0;
			j=0;
			aTemp = a[0];
			while(aTemp<r2w0)
			{
				j++;
				aTemp += a[j];
			}
			for (k = 0; k < NMOLECULAR; k++)
			{
				x[k] += s[k][j];
			}
			if(*lfTime>nTRecord)
			{
				plfTime[int(*lfTime)] += *lfTime;
				for (k = 0; k < NMOLECULAR; k++)
				{
					pnXnum[0][k][int(*lfTime)] += x[k];
					pnXnum[1][k][int(*lfTime)]++;
					pSingalU[int(*lfTime)] = nUSignal;
					pSingalV[int(*lfTime)] = nVSignal;
				}
				if(nTRecord>*nRecord)
				{
					*nRecord = int(nTRecord);
				}
				nTRecord = int(*lfTime)+1;
			}
		}
	}
	*lfTime = lfTlimit;
	return *nRecord;
}
